#include "TextureTestScene.h"
#include "DirectX.h"
#include "DrawBuffer.h"
#include "Texture.h"

#define FVF_CUSTOM2D    (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

struct SimpleVertex
{
	float x, y, z;
	float rhw;
	DWORD color;
	float u, v;
};

TextureData g_texData;
IDirect3DVertexBuffer9* g_pVertexBuffer;

// 
static bool SceneInit(void)
{
	// assetstH_bridge.pngeNX`[Ƃēǂݍ
	if( !LoadTexture(TEXT("assets/bridge.png"), &g_texData) )
	{
		return false;
	}
	// 摜TCY畝ƍݒ
	float rect[] =
	{
		10.0f, 10.0f,
		10.0f + (float)g_texData.srcWidth, 10.0f + (float)g_texData.srcHeight,
	};
	// eNX`[TCY摜TCYUV擾(摜2̗ݏł1.0fɂȂ)
	float u = (float)g_texData.srcWidth / (float)g_texData.width;
	float v = (float)g_texData.srcHeight / (float)g_texData.height;
	// 摜TCYɍ킹UVǉ_f[^
	const SimpleVertex vertices[4] =
	{
		// 1ڂ̋`
		{ rect[0], rect[1], 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
		{ rect[2], rect[1], 0.0f, 1.0f, 0xffffffff,    u, 0.0f },
		{ rect[0], rect[3], 0.0f, 1.0f, 0xffffffff, 0.0f,    v },
		{ rect[2], rect[3], 0.0f, 1.0f, 0xffffffff,    u,    v },
	};
	// _obt@̐
	g_pVertexBuffer = CreateVertexBuffer(vertices, sizeof(vertices));
	if( g_pVertexBuffer == NULL )
	{
		return false;
	}
	return true;
}

// 
static void SceneFinal(void)
{
	ReleaseTexture(&g_texData);
	SAFE_RELEASE(g_pVertexBuffer);
}

// XV
static void SceneUpdate(void)
{
}

// `
static void SceneRender(void)
{
	IDirect3DDevice9* pDevice = GetDirect3DDevice();
	// obNobt@̃NA
	pDevice->Clear(0, NULL, D3DCLEAR_TARGET, 0xff5f5f5f, 1.0f, 0);

	// ftHg̕`Xe[gݒ
	SetDefaultRenderState();
	// ʏ폑݃[hɐݒ
	SetRenderMode(ERenderMode::Normal, false);

	// eNX`[̐ݒ
	pDevice->SetTexture(0, g_texData.pTexture);
	// _obt@̐ݒ
	pDevice->SetStreamSource(0, g_pVertexBuffer, 0, sizeof(SimpleVertex));

	// _tH[}bg̎w
	pDevice->SetFVF(FVF_CUSTOM2D);
	// `
	pDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
}

// V[̐ݒ
SceneProc SetupTextureTestScene(void)
{
	SceneProc proc =
	{
		"TextureTest",
		SceneInit,
		SceneFinal,
		SceneUpdate,
		SceneRender,
	};
	return proc;
}